import numpy as np
from hw1_utils import load_data


def softmax(x):
    """softmax Softmax activation function

    The post-softmax logits are:
        Si = exp(x_i) / sum exp(x_j) for j = 1 ... n

    But your input x is a mini-batch, so you need generalize
    the expression above to an input with a shape of (N, C)
    where N is the number of instances and C is the number of classes

    Arguments:
        x {np.float np.ndarray} -- Input logits

    Returns:
        [np.float np.ndarray] -- Post-softmax probits
    """

    # >> Your code here. <<

    pass


def sgd(epochs, lr, W, b, X, y, batch_size=64):
    """sgd Run SGD optimization all the parameters

    Arguments:
        epochs {int} -- The number of epochs for training.
        lr {float} -- The learning rate for each epoch
        W {np.float np.ndarray} -- Initial weight matrix
        b {np.float np.ndarray} -- Initial bias
        X {np.float np.ndarray} -- Input dataset
        y {np.int np.ndarray} -- Groud truth

    Keyword Arguments:
        batch_size {int} -- The number of samples in each mini-batch
             (default: {64})

    Returns:
        {np.float np.ndarray} -- Optimal weight
        {np.float np.ndarray} -- and bias
    """

    W_optimal = None
    b_optimal = None

    # >> Your code starts here. <<

    # >> Your code ends here. <<

    return W_optimal, b_optimal


def evaluate(X_test, y_test, W, b):
    """test_accuracy Evaluate the model accuracy on the test dataset

    Arguments:
        X_test {np.float np.ndarray} -- Input dataset
        y_test {np.int np.ndarray} -- Groud truth
        W {np.float np.ndarray} -- Weight matrix
        b {np.float np.ndarray} -- Bias
    """

    # >> Your code starts here. <<

    pass


def run_numpy(epochs=10, learning_rate=1.0, batch_size=64):
    """run_numpy Load the data, initialize and train a model, and evaluate it.

    Keyword Arguments:
        epochs {int} -- The number of epochs for training.
        learning_rate {float} -- The learning rate for each epoch
        batch_size {int} -- The number of samples in each mini-batch
             (default: {64})

    Returns:
        {float} -- Model's test accuracy.
    """

    X_train, y_train, X_val, y_val, X_test, y_test = load_data('mnist.pkl.gz')

    test_accuracy = None

    # >> Your code starts here. <<

    # >> Your code ends here. <<

    print('Test Accuracy: {}'.format(test_accuracy))

    return test_accuracy


if __name__ == '__main__':
    run_numpy()
