import gzip
import pickle as pkl


def load_data(path):
    with gzip.open(path, 'rb') as f:
        try:
            # Python3.
            (train_X, train_y),\
            (val_X, val_y),\
            (test_X, test_y) = pkl.load(f, encoding='latin1')
        except:
            # Python2.
            (train_X, train_y),\
            (val_X, val_y),\
            (test_X, test_y) = pkl.load(f)

    return train_X, train_y, val_X, val_y, test_X, test_y
